#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

//----------------------------------------------------------------------------//
//------------- petites procedures utiles ------------------------------------//
//----------------------------------------------------------------------------//


// afficher un message popup
void afficher_message (gchar *chaine)
{
 GtkWidget *dialog;	
 //On affiche le texte dans une boite de dialogue.
 dialog = gtk_message_dialog_new(NULL,
 GTK_DIALOG_MODAL,
 GTK_MESSAGE_INFO,
 GTK_BUTTONS_OK,
 "Message :\n%s", chaine);

 gtk_dialog_run(GTK_DIALOG(dialog));
 gtk_widget_destroy(dialog);
}

// lire le contenu d'une entry connaissant son nom
const gchar * lire_entry (GtkWidget *button, gchar *c)
{
  GtkWidget *entry = lookup_widget(GTK_WIDGET(button), c);
  g_print("lire_entry = %s\n", c);
  const gchar *chaine ;	
  chaine = gtk_entry_get_text(GTK_ENTRY(entry));

  g_print("chaine lue = %s\n", chaine);
  return chaine;
	
}

// lire le contenu d'un textview
gchar * lire_text_view (GtkWidget *button, gchar *c)
{
 GtkWidget *view = 	lookup_widget(GTK_WIDGET(button), c);
	
 GtkTextBuffer* text_buffer=0;
 GtkTextIter start;
 GtkTextIter end;
 gchar* buf=0;
 GtkWidget *dialog;
	
 //On recupere le buffer
 text_buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(view));
 //On recupere l'origine du buffer
 gtk_text_buffer_get_start_iter(text_buffer,&start);
 //On recupere la fin du buffer
 gtk_text_buffer_get_end_iter(text_buffer,&end);	
	
 //On copie le contenu du buffer dans une variable
 buf=gtk_text_buffer_get_text(text_buffer,&start, &end,TRUE);
	
 return buf;	
}


void ecrire_text_view (GtkWidget *button, gchar *c, gchar *texte)
{
 GtkWidget *view = 	lookup_widget(GTK_WIDGET(button), c);
 GtkTextIter iter;
 GtkTextBuffer *p_text_buffer = NULL;
	
 //cb_new (NULL, view);
 p_text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW(view));
	

 gtk_text_buffer_get_iter_at_line (p_text_buffer, &iter, 0);
 gtk_text_buffer_insert (p_text_buffer, &iter, texte, -1);

}

void effacer_text_view (GtkWidget *button, gchar *c)
{
    GtkWidget *view = 	lookup_widget(GTK_WIDGET(button), c);
    GtkTextIter start;
    GtkTextIter end;
    GtkTextBuffer *p_text_buffer = NULL;
 
    p_text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW(view));
    gtk_text_buffer_get_bounds (p_text_buffer, &start, &end);
    gtk_text_buffer_delete (p_text_buffer, &start, &end);

}


// ecrire un message sur l'entry connaissant son nom
void ecrire_entry (GtkWidget *button, gchar *c, gchar *chaine)
{
  GtkWidget *entry = lookup_widget(GTK_WIDGET(button), c);
  gtk_entry_set_text(GTK_ENTRY(entry), chaine);
}



#if GTK_CHECK_VERSION (2, 6, 0)
#define combo_box_active_get_text(combo_box) gtk_combo_box_get_active_text (combo_box)
#else
char *combo_box_active_get_text (GtkComboBox *combo_box)
{
  gchar *s_text = NULL;
  gboolean b_ret = FALSE;
  GtkTreeIter iter;

  g_return_val_if_fail (combo_box != NULL, s_text);

  b_ret = gtk_combo_box_get_active_iter (combo_box, &iter);
  if (b_ret)
  {
    GtkTreeModel *p_model = NULL;

    p_model = gtk_combo_box_get_model (combo_box);
    if (p_model != NULL)
    {
      gtk_tree_model_get (p_model, &iter, 0, &s_text, -1);
    }
  }
  return s_text;
}
#endif



//----------------------------------------------------------------------------//
//---------------------- button 1 --------------------------------------------//
//----------------------------------------------------------------------------//

// traitement du bouton2
void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ 
 
	
  ecrire_entry (GTK_WIDGET(button), "entry1", "démontration, on écrit...");
	
  
	
}


//----------------------------------------------------------------------------//
//---------------------- button 2 --------------------------------------------//
//----------------------------------------------------------------------------//

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_main_quit();
}





//----------------------------------------------------------------------------//
//---------------------- scroll bart verticale -------------------------------//
//----------------------------------------------------------------------------//

gboolean
on_vscrollbar1_change_value            (GtkRange        *range,
                                        GtkScrollType    scroll,
                                        gdouble          value,
                                        gpointer         user_data)
{
  afficher_message ("on_vscrollbar1_change_value appelée \n");
  return FALSE;
}


void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	
 GtkWidget *p_dialog = NULL;
 p_dialog = gtk_file_chooser_dialog_new ("Choisir un fichier", NULL,
                                         GTK_FILE_CHOOSER_ACTION_OPEN,
                                         GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                         GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                                         NULL);
	
 gtk_dialog_run(GTK_DIALOG(p_dialog));
	
 if (gtk_dialog_run (GTK_DIALOG (p_dialog)) == GTK_RESPONSE_ACCEPT)
 {
  gchar *file_name = NULL;
  file_name = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (p_dialog));	
	 
  gchar *label = g_strdup_printf ("Fichier :  %s \n", file_name);
 
  ecrire_text_view (GTK_WIDGET(button), "textview1", label);
  g_free (file_name); 
  g_free (label);	 
 }
	
	
 gtk_widget_destroy(p_dialog);		

}


void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  const gchar * temp;
	
  temp = lire_entry(GTK_WIDGET(button), "entry1");	
	
  g_print("entry1 contient le texte= %s\n", temp);
  
  afficher_message (temp); 

}


void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	
 ecrire_text_view (GTK_WIDGET(button), "textview1", "ceci est une démonstration\n");	

}


void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar* buf=0;
  buf = lire_text_view(GTK_WIDGET(button), "textview1");

  afficher_message (buf);
	
  g_free(buf);	
	
}


void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 afficher_message ("demonstration de fenetre popup\n"); 
}


void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{


 GtkWidget *p_dialog = NULL;
 p_dialog = gtk_file_chooser_dialog_new ("Enregistrer sous", NULL,
                                         GTK_FILE_CHOOSER_ACTION_OPEN,
                                         GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                         GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                                         NULL);
	
 gtk_dialog_run(GTK_DIALOG(p_dialog));
	
 if (gtk_dialog_run (GTK_DIALOG (p_dialog)) == GTK_RESPONSE_ACCEPT)
 {
  gchar *file_name = NULL;
  file_name = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (p_dialog));	
	 
  gchar *label = g_strdup_printf ("Fichier :  %s \n", file_name);
 
  ecrire_text_view (GTK_WIDGET(button), "textview1", label);
  g_free (file_name); 
  g_free (label);	 
 }
	
	
 gtk_widget_destroy(p_dialog);	
}


void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  effacer_text_view (GTK_WIDGET(button), "textview1");
}


void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ 
 
	
 GtkWidget *Combo = 	lookup_widget(GTK_WIDGET(button), "combobox1");
	
 gtk_combo_box_append_text (GTK_COMBO_BOX (Combo),"coucou");
 gtk_combo_box_append_text (GTK_COMBO_BOX (Combo), "ceci montre comment faire");
 gtk_combo_box_append_text (GTK_COMBO_BOX (Combo), "pour remplir un combobox");
	
 gtk_combo_box_set_active (GTK_COMBO_BOX (Combo), 1);	
	
}


void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget *Combo = 	lookup_widget(GTK_WIDGET(button), "combobox1");
	
 gchar* buf=0;
 buf = combo_box_active_get_text (GTK_COMBO_BOX(Combo));
	
 gchar *label = g_strdup_printf ("votre choix :  %s \n", buf);	
 afficher_message (label);
}


void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget *p_dialog = NULL;
 p_dialog = gtk_file_chooser_dialog_new ("Choisir un fichier", NULL,
                                         GTK_FILE_CHOOSER_ACTION_OPEN,
                                         GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                                         GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                                         NULL);
	
 gtk_dialog_run(GTK_DIALOG(p_dialog));
	
 if (gtk_dialog_run (GTK_DIALOG (p_dialog)) == GTK_RESPONSE_ACCEPT)
 {
  gchar *file_name = NULL;
  file_name = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (p_dialog));	
	 
  GtkWidget *Image = 	lookup_widget(GTK_WIDGET(button), "image1");	

  gtk_image_set_from_file (Image, file_name);
	 
  g_free (file_name); 
 
 }
	
 gtk_widget_destroy(p_dialog);
	
}

